package com.baijiayun.video;

import android.content.Context;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentPagerAdapter;

import java.util.List;

/**
 * Created by yangjingming on 2018/7/30.
 */

public class ViewPagerAdapter extends FragmentPagerAdapter {

    private List<Fragment> fragments;
    private Context context;

    public ViewPagerAdapter(Context context, List<Fragment> fragmentList, FragmentManager fm) {
        super(fm);
        this.context = context;
        this.fragments = fragmentList;
    }

    @Override
    public Fragment getItem(int position) {
        return fragments == null ? null : fragments.get(position % fragments.size());
    }

    @Override
    public int getCount() {
        return fragments == null ? 0 : fragments.size();
    }
}
