package com.baijiayun.video;


import android.content.Context;
import android.graphics.Color;
import android.os.Bundle;
import android.text.SpannableString;
import android.text.style.ForegroundColorSpan;
import android.text.style.RelativeSizeSpan;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import com.baijiayun.videoplayer.IBJYVideoPlayer;
import com.baijiayun.videoplayer.core.demo.R;

/**
 * Created by yangjingming on 2018/7/30.
 */

public class SecondFragment extends Fragment {

    private View secondView;


    private TextView textView;


    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, Bundle saveInstanceState){
        super.onCreateView(inflater, container, saveInstanceState);
        secondView = LayoutInflater.from(getActivity()).inflate(R.layout.activity_second_fragment, null);


        textView = secondView.findViewById(R.id.activity_report_log);
        String s = "Report To Server";
        SpannableString ss1=  new SpannableString(s);
        ss1.setSpan(new RelativeSizeSpan(2f), 0, s.length(), 0); // set size
        ss1.setSpan(new ForegroundColorSpan(Color.BLACK), 0, s.length(), 0);// set color
        textView.setText(ss1);
        textView.setTextSize(15);
        textView.append("\n\n");

        return secondView;

    }

    public void setArguments(Context context, IBJYVideoPlayer videoPlayer){
    }

    @Override
    public void onDestroy(){
        super.onDestroy();
        secondView = null;

    }
}
